import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';
import '../../../support/step_definitions/doc_view_steps';

When('I visit the settings page', () => {
  cy.visit(`/spirit_hub/settings`);
});

Then('I can see the settings page title', () => {
  cy.get('h2').contains("Paramètres de l'instance").should('exist');
});

Then('I should not see the settings button', () => {
  cy.get('a[href*="/spirit_hub/settings"]').should('not.exist');
});

Then('I can inline edit {string} with value {string}', (setting_name, value) => {
  cy.get(`div[id*=inline_value_${setting_name}] button`).first().click();
  const input = cy.get(`#spirit_hub_setting_${setting_name}`);
  input.clear();
  input.type(value);
  input.next('div').find('button[type="submit"]').click();
  cy.get(`div[id*=inline_value_${setting_name}] div`).first().contains(value);
});

Given('There is a main object named {string}', (object_name) => {
  cy.get('a[href*="/spirit_hub/operations"]').contains(`${object_name}s`).should('exist');
  cy.get('button[type="submit"]').contains(`Ajouter un ${object_name.toLowerCase()}`).should('exist');
});

Given('There is a main organism type named {string}', (organism_type) => {
  cy.visit('/spirit_hub/operations');
  cy.get('table thead th').contains(organism_type).should('exist');
});